"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.default = createDynamicObject;

var _doc = require("rxq/operators/doc");

var _genericobject = require("rxq/operators/genericobject");

var _operators = require("rxjs/operators");

var _of = require("rxjs/observable/of");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createDynamicObject(def$) {
    var firstDef$ = def$.pipe((0, _operators.first)());
    var newDef$ = def$.pipe((0, _operators.skip)(1));

    return function (app$) {

        // Create object if not already created
        var obj$ = app$.pipe((0, _operators.combineLatest)(firstDef$), (0, _operators.mergeMap)(function (_ref) {
            var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
                appHandle = _ref2[0],
                def = _ref2[1];

            return (0, _of.of)(appHandle).pipe((0, _doc.createSessionObject)(def));
        })).pipe((0, _operators.publishReplay)(1), (0, _operators.refCount)());;

        // Update object; Always connected, may need better way to handle connecting & disconnecting this
        obj$.pipe((0, _operators.combineLatest)(newDef$), (0, _operators.switchMap)(function (_ref3) {
            var _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
                objHandle = _ref4[0],
                def = _ref4[1];

            var h$ = (0, _of.of)(objHandle);
            return h$.pipe((0, _genericobject.setProperties)(def));
        }), (0, _operators.publish)()).connect();

        return obj$;
    };
}
module.exports = exports["default"];