"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = retryLayouts;

var _handle = require("rxq/operators/handle");

var _genericobject = require("rxq/operators/genericobject");

var _operators = require("rxjs/operators");

var _empty = require("rxjs/observable/empty");

function retryLayouts() {
    var n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3;
    var t = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    var silentError = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    return function (source$) {

        return source$.pipe((0, _handle.invalidated)(), (0, _operators.switchMap)(function (handle) {
            var layout$ = handle.call((0, _genericobject.getLayout)());

            return layout$.pipe((0, _operators.retryWhen)(function (err) {
                return err.pipe((0, _operators.delay)(t), (0, _operators.take)(n));
            }), (0, _operators.catchError)(function (err) {
                return silentError ? (0, _empty.empty)() : err;
            }));
        }));
    };
}
module.exports = exports["default"];