import { invalidated } from "rxq/operators/handle";
import { getLayout } from "rxq/operators/genericobject";
import { map, catchError, retryWhen, delay, take, switchMap } from "rxjs/operators";
import { empty } from "rxjs/observable/empty";

export default function retryLayouts() {
    var n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3;
    var t = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 100;
    var silentError = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    return function (source$) {

        return source$.pipe(invalidated(), switchMap(function (handle) {
            var layout$ = handle.call(getLayout());

            return layout$.pipe(retryWhen(function (err) {
                return err.pipe(delay(t), take(n));
            }), catchError(function (err) {
                return silentError ? empty() : err;
            }));
        }));
    };
}